"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");
var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.process_env_findAll = process_env_findAll;
exports.process_env_findInFile = process_env_findInFile;
exports.process_env_findInFile2 = process_env_findInFile2;
var _replaceAll = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/replace-all"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/filter"));
var _path = require("path");
var _fastGlob = _interopRequireDefault(require("fast-glob"));
var _fsExtra = require("fs-extra");
var tsm = _interopRequireWildcard(require("ts-morph"));
var _Array = require("../../x/Array");
var _tsMorph2 = require("../../x/ts-morph");
function process_env_findAll(dir) {
  return (0, _Array.iter)(function* () {
    var _context;
    // globSync only works with / as the path separator, even on Windows
    const globPath = (0, _replaceAll.default)(_context = (0, _path.join)(dir, 'src/**/*.{js,ts,jsx,tsx}')).call(_context, '\\', '/');
    for (const file of _fastGlob.default.sync(globPath)) {
      yield* process_env_findInFile(file, (0, _fsExtra.readFileSync)(file).toString());
    }
  });
}
function process_env_findInFile(filePath, text) {
  if (!(0, _includes.default)(text).call(text, 'process.env')) {
    return [];
  }
  try {
    return process_env_findInFile2((0, _tsMorph2.createTSMSourceFile_cached)(filePath, text));
  } catch (e) {
    return [];
  }
}
function process_env_findInFile2(sf) {
  var _context2;
  const penvs = (0, _filter.default)(_context2 = sf.getDescendantsOfKind(tsm.SyntaxKind.PropertyAccessExpression)).call(_context2, is_process_env);
  return (0, _Array.iter)(function* () {
    for (const penv of penvs) {
      const node = penv.getParent();
      if (!node) {
        continue;
      }
      if (tsm.Node.isPropertyAccessExpression(node)) {
        yield {
          key: node.getName(),
          node
        };
      } else if (tsm.Node.isElementAccessExpression(node)) {
        const arg = node.getArgumentExpression();
        if (!arg) {
          continue;
        }
        if (!tsm.Node.isStringLiteral(arg)) {
          continue;
        }
        yield {
          key: arg.getLiteralText(),
          node
        };
      }
    }
  });
}
function is_process_env(n) {
  if (!tsm.Node.isPropertyAccessExpression(n)) {
    return false;
  }
  return n.getExpression().getText() === 'process' && n.getName() === 'env';
}